package poly;

/*
 * abstract class for a general Resource
 */

public abstract class Rc{
	public String name="";
	public int value=0;
	public int semaphore=0;

	public Rc(String Name, int Value, int Semaphore) throws PolyException{
		name=Name;
		value=Value;
		semaphore=Semaphore;

		if (Poly.rc_count>=Poly.MAX_RESOURCES){
			throw new PolyException("too many resources");
		}
		Poly.resources[Poly.rc_count++]=this;
	}
	
	public boolean can_read(){
		return true;
	}

	public boolean can_write(){
		return semaphore==0;
	}

	public int inc_sema(){
	// increments the semaphore value and returns its old value;
	// resource enaging.
		return semaphore++;
	}

	public int dec_sema(){
	// decrements the semaphore value and returns its old value;
	// resource releasing.
		return semaphore--;
	}

	public int read(Target t) throws PolyException{
	// stack resource could mess with hybernating a Target
	// returns the value

		dec_sema();

		return value;
	}

	public int write(Target t, int V) throws PolyException{
	// sets a new value V; 
	// stack could mess with hybernating a Target
	// returns the old value

		int v=value;
		value=V;

		inc_sema();

		return v;
	}
}
