/*
 * simple VCG detector. perhaps, i will have time to improve it to detect
 * (m)any mutating stammes (at least, using virbase data with description 
 * of it). i mean, not only VCG
 
 * currently detects BELKA stamm only
 */

package utils.tools;

import utils.av.*;
import utils.tools.belkodav.*;

public class Belkodav extends ZemskijFershal {

	public static final String NEXT_HEURISTIC = null;

	public static final String VIRNAME = "BELKA";
	static final int V1 = 0;
	static final int V2_PARENT = 1;
	static final int V2_CHILD = 2;
	static byte [] signature = new byte[0];

	static final int LABEL_COUNT = 9;
	static final int CONSTS_COUNT = 7;
	static final int BYTES_READ_CONST = 5;
	static final int RETN_OFFSET_CONST = 6;
	static final int UNDEFINED_LABEL = -1;
	static final int UNPROCESSED_LABEL = 0x80000000;
	public static final int UNDEFINED_CONST = -1;
	public static final int UNDEFINED_REGISTER = -1;

	// Codes of OPerations
	static final int INT21 = 0x21cd;
		// change of execution sequence 
	static final int CALL = 0xe8;
	static final int JMP = 0xe9;
	static final int JMPS = 0xeb;
	static final int JC = 0x72;
	static final int JNC = 0x73;
	static final int JZ = 0x74;
	static final int JNZ = 0x75;
	static final int RETN = 0xc3;

		// one byte operations
	static final int LODSB = 0xac;
	static final int LODSW = 0xad;
	static final int STOSB = 0xaa;
	static final int STOSW = 0xab;
	static final int NOP = 0x90;
		// one byte register dependant
	static final int COPREG_MASK = 7;
	static final int INC_R = 0x40;
	static final int DEC_R = 0x48;
	static final int PUSH_R = 0x50;
	static final int POP_R = 0x58;
			// operations with AX
	static final int XCHG_AR = 0x90;

		// one byte COP, and two bytes of data follow
	static final int ADD_AV = 0x05;	// special instructions for AX
	static final int XOR_AV = 0x35;
	static final int SUB_AV = 0x2d;
	static final int CMP_AV = 0x3d;

	static final int MOV_RV = 0xb8;

		// prefixed operations
	static final int MAGIC_PREFIX = 0x81;
	static final int ADD_RV = 0xc0;	// these go after magic prefix
	static final int SUB_RV = 0xe8;
	static final int XOR_RV = 0xf0;
	static final int CMP_RV = 0xf8;

		// two byte ops using ModRM byte to define the register pair
	static final int SRCREG_MASK = 7;	// mask for ModRM to obtain src register
	static final int RR_MASK = 0xc0;	// mask for ModRM to form 
						//{reg,reg} operation

	static final int MOV_RR = 0x8b;	// these use modrm
	static final int XOR_RR = 0x33;
	static final int ADD_RR = 0x03;
	static final int SUB_RR = 0x2b;
	static final int XCHG_RR = 0x87;

	// register numbers 
	static final int _AX = 0;
	static final int _BX = 3;
	static final int _CX = 1;
	static final int _DX = 2;
	static final int _SI = 6;
	static final int _DI = 7;
	static final int _BP = 5;
	static final int _SP = 4;

	static Reg AX = new Reg(_AX);
	static Reg BX = new Reg(_BX);
	static Reg CX = new Reg(_CX);
	static Reg DX = new Reg(_DX);
	static Reg SI = new Reg(_SI);
	static Reg DI = new Reg(_DI);
	static Reg BP = new Reg(_BP);
	static Reg SP = new Reg(_SP);

	int [] labels;
	Int [] consts;
	int curr_pos;		// current position in file
	int oldpos;		// old position in file; token detectors should restore it if they fail
	byte [] infile;

	public Belkodav(){
		labels = new int[LABEL_COUNT];
		consts = new Int[CONSTS_COUNT];
	}

	public Result apply( Result prev ){
		prev.consult=NEXT_HEURISTIC;
		for (int i=0; i<LABEL_COUNT; i++){
			labels[i]=UNDEFINED_LABEL;
		}

		for (int i=0; i<CONSTS_COUNT; i++){
			consts[i]=new Int();
		}

		infile=prev.file;

		oldpos=0;
		curr_pos=oldpos;

		Int version=new Int();
		boolean result = jmp(0) && //dbg("jmp label0") && // jmp label0
				label(0) && //dbg("label0:") && 
				set_const(consts[0], labels[0]-3, 2) &&
				mrr(DI, SI) && //dbg("mov di,si") && 
				mrv(AX, labels[0]) && //dbg("mov ax,offset label0-100") && 
					 // label0 is already defined
				arv(AX, 0x100) && //dbg("add ax,100") && 
				mrr(SI, AX) && //dbg("mov si,ax") && 
				mrr(BP, AX) && //dbg("mov bp,ax") && 

				restoring_bytes(version) && 

				mrr(DI, SI) && //dbg("mov di,si") &&
				add_rv(DI, consts[0]) && //dbg("add di,const0 "+curr_pos) &&// i may also put here arv() with the same parameters :-)

				mrv(AX, 0x2e2a) && //dbg("mov ax, \'.*\'")&&	// mov ax, ".*"
				nope() && //dbg("nop? "+curr_pos) &&
				stosw() && //dbg("stosw "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				mrv(AX, 0x6f63) && //dbg("mov ax,'oc' "+curr_pos) &&	// mov ax, "oc"
				nope() && //dbg("nop? "+curr_pos) &&
				stosw() && //dbg("stosw "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				mrv(AX, 0x6d) && //dbg("mov ax, 'm'"+curr_pos)&&	// mov ax, "\0m"
				nope() && //dbg("nop "+curr_pos) &&
				stosw() && //dbg("stosw "+curr_pos) &&
				nope() && //dbg("nop "+curr_pos) &&

				mrv(AX, 0x4a00) && //dbg("mov ax,4a00 "+curr_pos) &&
				mrv(BX, 0x2000) && //dbg("mov bx,2000 "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) && 
				mrv(AX, 0x1a00) && //dbg("mov ax,1a00 "+curr_pos) && 
				mov_rv(DX, consts[0]) && //dbg("mov dx,const0 "+curr_pos) && // i could use mrv for more general case
				arv(DX, 0x10) && //dbg("add dx,10 "+curr_pos) && 
				arr(DX, BP) && //dbg("add dx,bp "+curr_pos) && 
				int21() && //dbg("int 21 "+curr_pos) && 
				mrr(BP, SI) && //dbg("mov bp,si "+curr_pos) && 
				mrv(AX, 0x4e00) && //dbg("mov ax,4e00 "+curr_pos) && 
				mrr(DX, BP) && //dbg("mov dx,bp "+curr_pos) &&
				add_rv(DX, consts[0]) && //dbg("add dx,const0 "+curr_pos) &&
				mrv(CX, 0) && //dbg("mov cx,0 "+curr_pos) &&

				label(1) &&//dbg("label1: "+curr_pos) &&
				int21() &&//dbg("int 21 "+curr_pos) &&
				jcc(JNC, 2) &&//dbg("jnc label2 "+curr_pos) &&

				mrv(AX, 0x1a00) && //dbg("mov ax,1a00 "+curr_pos) &&
				mrv(DX, 0x8000) && //dbg("mov dx,8000 "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) &&
				mrv(AX, consts[RETN_OFFSET_CONST]) && //dbg("mov ax,"+consts[RETN_OFFSET_CONST].i+" "+curr_pos) &&
				push_r(AX) && //dbg("push ax "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				retn() && //dbg("retn "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				
				label(2) && //dbg("label2: "+curr_pos) && 
				mrr(SI, BP) && //dbg("mov si,bp "+curr_pos) &&
				add_rv(SI, consts[0]) && //dbg("add si,const0 "+curr_pos) &&
				arv(SI, 0x2a) && //dbg("add si,2a "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				lodsw() && //dbg("lodsw "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				cmp_rv(AX, 0x400) && //dbg("cmp ax,400 "+curr_pos) &&
				jcc(JNC, 3) && //dbg("jnc label3 "+curr_pos) &&

				label(4) && //dbg("label4: "+curr_pos) &&
				mrv(AX, 0x4f00) && //dbg("mov ax,4f00 "+curr_pos) &&
				jmp(1) && //dbg("jmp label1 "+curr_pos) &&

				label(3) && 	// i could put here process_label() instead
						//dbg("label3: "+curr_pos) &&
				cmp_rv(AX, 0xc800) && //dbg("cmp ax,0c800 "+curr_pos) &&
				jcc(JC, 5) && //dbg("jc label5 "+curr_pos) &&
				jmp(4) && //dbg("jmp label4 "+curr_pos) &&

				label(5) &&  //dbg("label5: "+curr_pos) && 
				mrv(AX, 0x4301) && //dbg("mov ax,4301 "+curr_pos) &&
				mrr(DX, BP) && //dbg("mov dx,bp "+curr_pos) &&
				add_rv(DX, consts[0]) && //dbg("add dx,const0 "+curr_pos) &&
				arv(DX, 0x2e) && //dbg("add dx,2e "+curr_pos) &&
				mrv(CX, 0) && //dbg("mov cx,0 "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) &&
				mrv(AX, 0x3d02) && //dbg("mov ax,3d02 "+curr_pos) &&
				mrr(DX, BP) && //dbg("mov dx,bp "+curr_pos) &&
				add_rv(DX, consts[0]) && //dbg("add dx,const0 "+curr_pos) &&
				arv(DX, 0x2e) && //dbg("add dx,2e "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) &&
				mrr(BX, AX) && //dbg("mov bx,ax "+curr_pos) &&
				mrv(AX, 0x3f00) && //dbg("mov ax,3f00 "+curr_pos) &&
				mrr(DX, BP) && //dbg("mov dx,bp "+curr_pos) &&
				add_rv(DX, consts[0]) && //dbg("add dx,const0 "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				push_r(DX) && //dbg("push dx "+curr_pos) &&
				mrv(CX, consts[BYTES_READ_CONST]) && //dbg("mov cx,"+consts[BYTES_READ_CONST].i+" "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) &&
				pop_r(SI) && //dbg("pop si "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				arv(SI, 3) && //dbg("add si,3 "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&

				compare_signature_bytes(version) &&
				jcc(JNZ, 7) && //dbg("jnz label7 "+curr_pos) &&
				
				label(6) && //dbg("label6: "+curr_pos) && 
				mrv(AX, 0x3e00) && //dbg("mov ax,3e00 "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) &&
				mrv(AX, 0x4301) && //dbg("mov ax,4301 "+curr_pos) &&
				mrr(DX, BP) && //dbg("mov dx,bp "+curr_pos) &&
				add_rv(DX, consts[0]) && //dbg("add dx,const0 "+curr_pos) &&
				arv(DX, 0x2e) && //dbg("add dx,2e "+curr_pos) &&
				mrv(CX, 1) && //dbg("mov cx,1 "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) &&
				jmp(4) && //dbg("jmp label4 "+curr_pos) &&
				
				label(7) && //dbg("label7: "+curr_pos) && 
				mrv(AX, 0x4200) && //dbg("mov ax,4200 "+curr_pos) &&
				mrv(CX, 0) && //dbg("mov cx,0 "+curr_pos) &&
				mrv(DX, 0) && //dbg("mov dx,0 "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) &&
				mrr(DI, BP) && //dbg("mov dx,bp "+curr_pos) &&
				add_rv(DI, consts[0]) && //dbg("add dx,const0 "+curr_pos) &&
				arv(DI, consts[BYTES_READ_CONST]) && //dbg("add di,"+consts[BYTES_READ_CONST].i+" "+curr_pos) &&

				mrv(AX, 0xe9) && //dbg("mov ax,0e9 "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				stosb() && //dbg("stosb "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&

				mrr(SI, BP) && //dbg("mov si,bp "+curr_pos) &&
				add_rv(SI, consts[0]) && //dbg("add si,const0 "+curr_pos) &&
				arv(SI, 0x2a) && //dbg("add si,2a "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				lodsw() && //dbg("lodsw "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				stosw() && //dbg("stosw "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&

				create_signature(version) &&

				nope() && //dbg("nop? "+curr_pos) &&
				stosb() && //dbg("stosb "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&

				mrv(AX, 0x4000) && //dbg("mov ax,4000 "+curr_pos) &&
				mrr(DX, BP) && //dbg("mov dx,bp "+curr_pos) &&
				add_rv(DX, consts[0]) && //dbg("add dx,const0 "+curr_pos) &&
				arv(DX, consts[BYTES_READ_CONST]) && //dbg("add dx,"+consts[BYTES_READ_CONST].i+" "+curr_pos) &&
				mrv(CX, consts[BYTES_READ_CONST]) && //dbg("mov cx,"+consts[BYTES_READ_CONST].i+" "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) &&

				mrv(AX, 0x4202) && //dbg("mov ax,4202 "+curr_pos) &&
				mrv(CX, 0) && //dbg("mov cx,0 "+curr_pos) &&
				mrv(DX, 0) && //dbg("mov dx,0 "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) &&
				call(8) &&//dbg("call label8 "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				jmp(6) && //dbg("jmp label6 "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				label(8) //&& dbg("label8: "+curr_pos)
		;

		if (result){
		// BELKA detected. check if it is fertile or not
			oldpos=curr_pos;
			result = mrv(AX, 0x4000) && //dbg("mov ax,4000 "+curr_pos) &&
				mrr(DX, BP) && //dbg("mov dx,bp "+curr_pos) &&
				srv(DX, 3) && //dbg("sub dx,3 "+curr_pos) &&
				mov_rv(CX, consts[0]) && //dbg("mov cx,const0 "+curr_pos) &&
				arv(CX, 3) && //dbg("add cx,3 "+curr_pos) &&
				int21() && //dbg("int 21 "+curr_pos) &&
				retn() && //dbg("retn "+curr_pos) &&
				nope();

			String virname=VIRNAME+".v"+(version.cmp(V1)? 1:2);
			if (result && curr_pos==infile.length){ // i may also check not the file length
				prev.diagnosis = Result.DETECTED;
				prev.verdict = virname+".child";
			}else{
				int i;
				for (i=0; i<signature.length && curr_pos<infile.length; i++, curr_pos++){
					if (infile[curr_pos]!=signature[i]) break;
				}

				if (i==signature.length){
					prev.diagnosis = Result.DETECTED;
					prev.verdict = virname+".parent";
				}
			}

			if (prev.diagnosis==Result.DETECTED){
				if (version.cmp(V2_CHILD)){
					return new Result(prev.verdict, null,
							Result.UNRECOVERABLE,
							prev.file, true, prev);
				}else{
					put(0, consts[1].i);
					put(2, consts[2].i);

					if (version.cmp(V1)){
						put(4, consts[3].i);
						put(6, consts[4].i);
					}
					byte [] f = new byte[labels[0]-3];
					for(int i=0; i<f.length; i++){
						f[i]=infile[i];
					}

					return new Result(prev.verdict, "GP", 
							Result.HEALED,
							f, true, prev);
				}
			}
		}

		return prev;
	}

	public void put(int offset, int what){
		infile[offset]=(byte)(what & 0xff);
		infile[offset+1] = (byte)((what >> 8) & 0xff);
	}

	public boolean set_const(Int num, int offset, int len){
	// sets constant to the value, located at offset and len bytes long
		num.i=0;
		for (int i=0; i<len && i<4; i++){	// 4 bytes long maximum
			num.i = (num.i & ~(0xffffffff << (i << 3))) | 
				(infile[offset+i] << (i << 3));
		}

		return true;
	}

	public boolean chk_label(int label, int offset){
		if (labels[label]==UNDEFINED_LABEL){
			labels[label]=offset | UNPROCESSED_LABEL;
		}

		if ( (labels[label] & ~UNPROCESSED_LABEL)!=offset || 
		     offset>=infile.length || offset<0){
			return false;
		}

		return true;
	}

	public boolean process_label(int label){
	// sets position to where the specified label points
	// regardless to whether it has been processed or not.
	// it is needed when a forward reference is encountered
	// and which may happen to be unresolved due to conditional branching
	// or calls to subroutines.
		curr_pos = (labels[label] &=~UNPROCESSED_LABEL);
		return true;
	}

	public boolean label(int l){
	// defines a label at current position; or checks, whether it corresponds
	// with previous references to it. if not, those references are bad, 
	// and therefore it is not the code we are looking for.
		if (!chk_label(l, curr_pos)){
			curr_pos=oldpos;
			return false;
		}

		return process_label(l);// go "there"; actually, set label to "PROCESSED" state
					// so any back references won't "go" back
	}

	/*
         * TERMINAL SYMBOLS
         */
	public boolean cop(int cop1){
		if (curr_pos<infile.length &&
		    infile[curr_pos]==(byte)cop1){
			curr_pos++;
			return true;
		}
		curr_pos=oldpos;
		return false;
	}

	public boolean copreg(int cop1, Reg reg){
		int r=reg.r;
		if (r==UNDEFINED_REGISTER){
			if (curr_pos<infile.length){
				r=infile[curr_pos] & COPREG_MASK;
			}else{
				curr_pos=oldpos;
				return false;
			}
		}
		boolean result=cop(cop1 | r);

		if (result){
			reg.r=r;
		}
		return result;
	}

	public boolean get_data(Int c){
	// function that gets the two bytes of data and stores them into consts
	// if consts=UNDEFINED_CONST; or simply compares with data stored in it
	// and returns true if they are equal

		int o=((infile[curr_pos] & 0xff) | 
			((infile[curr_pos+1] & 0xff) << 8)) & 0xffff;

		if (c.i==UNDEFINED_CONST){
			c.i=o;
		}

		if (c.i==o){
			curr_pos+=2;
			return true;
		}

		curr_pos=oldpos;
		return false;
	}

	public boolean copreg_data(int cop, Reg reg, Int c){
	// function for detecting three byte operations with the 1st byte - cop+reg
	// and the following word - the data
		int r=reg.r;

		if (curr_pos+3<=infile.length){
			if (r==UNDEFINED_REGISTER){
				r=infile[curr_pos] & COPREG_MASK;
			}

			if(infile[curr_pos]==(byte)(cop | r)){
				// the correct operation
				curr_pos++;
				if (get_data(c)){
					reg.r=r;
					return true;
				}
			}
		}

		curr_pos=oldpos;
		return false;
	}


	public boolean cop_rr(int cop, Reg dest, Reg src){
	// reckoning dest and src registers are defined and 
	// contain correct register numbers (within 0..7 range)
		if (curr_pos+2<=infile.length && infile[curr_pos]==(byte)cop){
			curr_pos++;
			int s=src.r, d=dest.r;

			if (s==UNDEFINED_REGISTER){
				s=infile[curr_pos] & SRCREG_MASK;
			}

			if (d==UNDEFINED_REGISTER){
				d=(infile[curr_pos] >> 3) & SRCREG_MASK;
			}

			if (infile[curr_pos]==(byte)(s | (d << 3) | RR_MASK)){
				curr_pos++;
				src.r=s;
				dest.r=d;
				return true;
			}
		}
		curr_pos=oldpos;
		return false;
	}


	public boolean prefix_copreg_data(int cop, Reg reg, Int c){
	// function for detecting prefixed cops with register in the cop
	// and following 2 bytes of data
		if (curr_pos+4<=infile.length &&
		    infile[curr_pos]==(byte)MAGIC_PREFIX){
			curr_pos++;
			return copreg_data(cop, reg, c);
		}

		curr_pos=oldpos;
		return false;
	}

	public boolean mov_rv(Reg reg, Int c){
		return copreg_data(MOV_RV, reg, c);
	}

	public boolean mov_rv(Reg reg, int c){
		return mov_rv(reg, new Int(c));
	}

	public boolean add_av(Int c){
		return copreg_data(ADD_AV, AX, c);
	}

	public boolean add_av(int v){
		return add_av(new Int(v));
	}

	public boolean xor_av(Int c){
		return copreg_data(XOR_AV, AX, c);
	}

	public boolean xor_av(int v){
		return xor_av(new Int(v));
	}

	public boolean sub_av(Int c){
		return copreg_data(SUB_AV, AX, c);
	}

	public boolean sub_av(int v){
		return sub_av(new Int(v));
	}

	public boolean cmp_av(Int c){
		return copreg_data(CMP_AV, AX, c);
	}

	public boolean cmp_av(int v){
		return cmp_av(new Int(v));
	}


	public boolean mov_rr(Reg dest, Reg src){
		return cop_rr(MOV_RR, dest, src);
	}

	public boolean mov_rr(int dest, int src){
		return mov_rr(new Reg(dest), new Reg(src));
	}

	public boolean xor_rr(Reg dest, Reg src){
		return cop_rr(XOR_RR, dest, src);
	}

	public boolean xor_rr(int dest, int src){
		return xor_rr(new Reg(dest), new Reg(src));
	}

	public boolean add_rr(Reg dest, Reg src){
		return cop_rr(ADD_RR, dest, src);
	}

	public boolean add_rr(int dest, int src){
		return add_rr(new Reg(dest), new Reg(src));
	}

	public boolean sub_rr(Reg dest, Reg src){
		return cop_rr(SUB_RR, dest, src);
	}

	public boolean sub_rr(int dest, int src){
		return sub_rr(new Reg(dest), new Reg(src));
	}

	public boolean xchg_rr(Reg dest, Reg src){
		if (dest.r==AX.r || dest.r==UNDEFINED_REGISTER){
			int op=oldpos;
			oldpos=curr_pos;

			Reg s = src.copy();
			boolean r=xchg_ar(s);
			oldpos=op;

			if (r){
				dest.r=AX.r;
				src.r=s.r;
				return true;
			}
		}

		return cop_rr(XCHG_RR, dest, src);
	}

	public boolean xchg_rr(int dest, int src){
		return xchg_rr(new Reg(dest), new Reg(src));
	}

	public boolean add_rv(Reg reg, Int c){
		if (reg.r==AX.r || reg.r==UNDEFINED_REGISTER){
			int op=oldpos;
			oldpos=curr_pos;

			boolean r=add_av(c);
			oldpos=op;


			if (r){
				reg.r=AX.r;
				return true;
			}
		}

		return prefix_copreg_data(ADD_RV, reg, c);
	}

	public boolean add_rv(Reg reg, int v){
		return add_rv(reg, new Int(v));
	}

	public boolean sub_rv(Reg reg, Int c){
		if (reg.r==AX.r || reg.r==UNDEFINED_REGISTER){
			int op=oldpos;
			oldpos=curr_pos;

			boolean r=sub_av(c);
			oldpos=op;


			if (r){
				reg.r=AX.r;
				return true;
			}
		}

		return prefix_copreg_data(SUB_RV, reg, c);
	}

	public boolean sub_rv(Reg reg, int v){
		return sub_rv(reg, new Int(v));
	}

	public boolean xor_rv(Reg reg, Int c){
		if (reg.r==AX.r || reg.r==UNDEFINED_REGISTER){
			int op=oldpos;
			oldpos=curr_pos;

			boolean r=xor_av(c);
			oldpos=op;


			if (r){
				reg.r=AX.r;
				return true;
			}
		}

		return prefix_copreg_data(XOR_RV, reg, c);
	}

	public boolean xor_rv(Reg reg, int v){
		return xor_rv(reg, new Int(v));
	}

	public boolean cmp_rv(Reg reg, Int c){
		if (reg.r==AX.r || reg.r==UNDEFINED_REGISTER){
			int op=oldpos;
			oldpos=curr_pos;

			boolean r=cmp_av(c);
			oldpos=op;


			if (r){
				reg.r=AX.r;
				return true;
			}
		}

		return prefix_copreg_data(CMP_RV, reg, c);
	}

	public boolean cmp_rv(Reg reg, int v){
		return cmp_rv(reg, new Int(v));
	}

	public boolean xchg_ar(Reg reg){
		return copreg(XCHG_AR, reg);
	}

	public boolean xchg_ar(int reg){
		return xchg_ar(new Reg(reg));
	}

	public boolean inc_r(Reg reg){
		return copreg(INC_R, reg);
	}

	public boolean inc_r(int reg){
		return inc_r(new Reg(reg));
	}

	public boolean dec_r(Reg reg){
		return copreg(DEC_R, reg);
	}

	public boolean dec_r(int reg){
		return dec_r(new Reg(reg));
	}

	public boolean push_r(Reg reg){
		return copreg(PUSH_R, reg);
	}

	public boolean push_r(int reg){
		return push_r(new Reg(reg));
	}

	public boolean pop_r(Reg reg){
		return copreg(POP_R, reg);
	}

	public boolean pop_r(int reg){
		return pop_r(new Reg(reg));
	}

	public boolean retn(){
		return cop(RETN);
	}

	public boolean lodsb(){
		return cop(LODSB);
	}

	public boolean lodsw(){
		return cop(LODSW);
	}

	public boolean stosb(){
		return cop(STOSB);
	}

	public boolean stosw(){
		return cop(STOSW);
	}

	public boolean nop(){
		return cop(NOP);
	}

	public boolean jump(int cop, int label, int len){
	// this is a jump to label, using code of operation cop and
	// relative offset len bytes long

		if (infile[curr_pos]!=(byte)cop || curr_pos+len+1>infile.length){
		// wrong COP or relative offset is beyond eof
			curr_pos=oldpos;
			return false;
		}

		curr_pos++;
		int offset=0;
		for (int i=0; i<len; i++, curr_pos++){
			offset=(offset & ~(0xffffffff << (i << 3))) | 
				(infile[curr_pos] << (i << 3));
				// let it also be negative
		}
		offset+=curr_pos;

		if (!chk_label(label, offset)){
		// no, this jmp points somewhere else (not as it was defined), 
		// or out of file
			curr_pos=oldpos;
			return false;
		}
		return true;
	}

	public boolean jmp(int label){
		if (jump(JMP, label, 2)){
			if((labels[label] & UNPROCESSED_LABEL) != 0){
				// go there
				process_label(label);
			}
			return true;
		}
		return false;
	}

	public boolean call(int label){
		return jump(CALL, label, 2);
	}

	public boolean jmps(int label){
		if (jump(JMPS, label, 1)){
			if((labels[label] & UNPROCESSED_LABEL) != 0){
				// go there
				process_label(label);
			}
			return true;
		}
		return false;
	}

	public boolean jcc(int cond, int label){
		return jump(cond, label, 1);
	}


	/*
         * NON-TERMINAL SYMBOLS
         */

	public boolean mrv(Reg reg, int v){
		return mrv(reg, new Int(v));
	}

	public boolean arv(Reg reg, int v){
		return arv(reg, new Int(v));
	}

	public boolean srv(Reg reg, int v){
		return srv(reg, new Int(v));
	}


	public boolean mrv(Reg r, Int val){
		Reg reg=r.copy();	// creating a "hardcopy" will not allow
		Int v=val.copy();	// lower theorems change (reset) the previous hipotesys
					// calling copy() methos instead of 
				// the constructor will save us some time
				// if a value cannot be changed by reset() (oi==i)

		int op=oldpos;
		oldpos=curr_pos;

		Int random1=new Int();
		Int v2=new Int();
		Reg reg1=new Reg();
		boolean result = (
					reg.reset() && v.reset() &&
					mov_rv(reg, random1) &&
					add_rv(reg, v) &&
					sub_rv(reg, random1)
				) || (
					reg.reset() && v.reset() &&
					push_r(reg1) &&
					exchange(reg, reg1) &&
					mov_rv(reg1, v) &&
					exchange(reg, reg1) &&
					pop_r(reg1)
				) || (
					reg.reset() && v.reset() && reg1.reset() && 
					mrr(reg, reg1) &&
					add_rv(reg, v) &&
					srr(reg, reg1)
				) || (
					reg.reset() && v.reset() && reg1.reset() &&
					exchange(reg, reg1) && //dbg("xchg "+reg.r+","+reg1.r) &&
					mov_rv(reg1, v) && //dbg("mov "+reg1.r+","+v.i) &&
					exchange(reg, reg1) //&& dbg("xchg "+reg.r+","+reg1.r)
				) || (
					reg.reset() && v.reset() && reg1.reset() && random1.reset() &&
					push_r(reg1) &&
					mov_rv(reg1, v) &&
					sub_rv(reg1, random1) &&
					exchange(reg, reg1) && 
					add_rv(reg, random1) &&
					pop_r(reg1)
				) || (
					reg.reset() && v.reset() && random1.reset() &&
					mov_rv(reg, v2) &&
					sub_rv(reg, random1) &&
					v.cmp(v2.i-random1.i)
				) || (
					reg.reset() && v.reset() &&
					random1.reset() && v2.reset() &&
					mov_rv(reg, v2) &&
					add_rv(reg, random1) &&
					v.cmp(v2.i+random1.i)
				) || (
					reg.reset() && v.reset() &&
					random1.reset() && v2.reset() &&
					mov_rv(reg, v2) &&
					xor_rv(reg, random1) &&
					v.cmp(v2.i ^ random1.i)
				) || mov_rv(reg, v);
			;
		oldpos=op;

		if (result){
			r.r=reg.r;	// propagate hipotesys, if there were any
			val.i=v.i;	// won't do any harm, if val.i were equal to val.oi
		}else{			// forget the found values 
				// for v and reg, if they were undefined
				// so they will remain being undefined
			curr_pos=oldpos;
		}
		return result;
	}


	public boolean arv(Reg r, Int val){
		Reg reg=r.copy();
		Int v=val.copy();

		int op=oldpos;
		oldpos=curr_pos;

		Int v1=new Int();
		Int v2=new Int();
		Reg r1=new Reg();
		boolean result = (
					reg.reset() && v.reset() &&
					add_rv(reg, v1) &&
					add_rv(reg, v) &&
					sub_rv(reg, v1)
				) || (
					reg.reset() && v.reset() &&
					exchange(reg, r1) && 
					add_rv(r1, v) && 
					exchange(reg, r1)
				) || (
					reg.reset() && v.reset() &&
					r1.reset() &&
					srr(reg, r1) &&
					add_rv(reg, v) &&
					arr(reg, r1)
				) || (
					reg.reset() && v.reset() &&
					r1.reset() &&
					arr(reg, r1) && 
					add_rv(reg, v) &&
					srr(reg, r1)
				) || (
					reg.reset() && v.reset() &&
					r1.reset() && v1.reset() &&
					push_r(r1) &&
					mrv(r1, v) &&
					arr(r1, reg) &&
					mrv(reg, v1) &&
					arr(reg, r1) &&
					sub_rv(reg, v1) &&
					pop_r(r1)
				) || (
					reg.reset() && v.reset() &&
					v1.reset() && v2.reset() &&
					add_rv(reg, v2) &&
					sub_rv(reg, v1) &&
					v.cmp(v2.i-v1.i)
				) || (
					reg.reset() && v.reset() &&
					v1.reset() && v2.reset() &&
					add_rv(reg, v2) &&
					add_rv(reg, v1) &&
					v.cmp(v2.i+v1.i)
				) || add_rv(reg, v);
			;


		oldpos=op;
		if (result){
			r.r=reg.r;
			val.i=v.i;
		}else{
			curr_pos=oldpos;
		}
		return result;
	}


	public boolean srv(Reg r, Int val){
		Reg reg=r.copy();
		Int v=val.copy();

		int op=oldpos;
		oldpos=curr_pos;

		Int v1=new Int();
		Int v2=new Int();
		Reg r1=new Reg();
		boolean result = // sub_rv(reg, v) || ( // no, this cannot stand at the front; 
			// because it is not definite. only after we try 
			// the following, and fail, then we may try simply sub_rv
				(
					reg.reset() && v.reset() &&
					sub_rv(reg, v1) &&
					sub_rv(reg, v) &&
					arv(reg, v1)
				) || (
					reg.reset() && v.reset() &&
					v1.reset() && 
					arv(reg, v1) &&
					sub_rv(reg, v) &&
					sub_rv(reg, v1)
				) || (
					reg.reset() && v.reset() &&
					r1.reset() && v1.reset() &&
					push_r(r1) &&
					mrv(r1, v) &&
					sub_rv(r1, v1) &&
					srr(reg, r1) &&
					sub_rv(reg, v1) &&
					pop_r(r1)
				) || (
					reg.reset() && v.reset() &&
					r1.reset() && 
					push_r(r1) &&
					mrv(r1, v) &&
					srr(reg, r1) &&
					pop_r(r1)
				) || (
					reg.reset() && v.reset() &&
					r1.reset() && 
					exchange(reg, r1) &&
					sub_rv(r1, v) &&
					exchange(reg, r1)
				) || (
					reg.reset() && v.reset() &&
					v1.reset() && 
					sub_rv(reg, v1) &&
					arv(reg, v2) &&
					v.cmp(v1.i+v2.i)
				) || (
					reg.reset() && v.reset() &&
					v1.reset() && v2.reset() &&
					sub_rv(reg, v1) &&
					sub_rv(reg, v2) &&
					v.cmp(v1.i-v2.i)
				) || sub_rv(reg, v);
			;


		oldpos=op;
		if (result){
			r.r=reg.r;
			val.i=v.i;
		}else{
			curr_pos=oldpos;
		}
		return result;
	}


	public boolean mrr(Reg reg, Reg reg1){
		Reg r=reg.copy();
		Reg r1=reg1.copy();

		int op=oldpos;
		oldpos=curr_pos;

		boolean result = mov_rr(r, r1) || (
					r.reset() && r1.reset() &&
					push_r(r1) && 
					exchange(r, r1) &&
					pop_r(r1)
				) || (
					r.reset() && r1.reset() &&
					sub_rr(r, r) &&
					add_rr(r, r1)
				) || (
					r.reset() && r1.reset() &&
					xor_rr(r, r) &&
					add_rr(r, r1) 
				) || (
					r.reset() && r1.reset() &&
					push_r(r1) &&
					pop_r(r)
				) || (
					r.reset() && r1.reset() &&
					mov_rv(r, 0) &&
					add_rr(r, r1)
				)
			;

		oldpos=op;
		if (result){
			reg.r=r.r;
			reg1.r=r1.r;
		}else{
			curr_pos=oldpos;
		}

		return result;
	}


	public boolean arr(Reg reg, Reg reg1){
		Reg r=reg.copy();
		Reg r1=reg1.copy();

		int op=oldpos;
		oldpos=curr_pos;

		Reg r2=new Reg();
		boolean result = add_rr(r, r1) || (
					r.reset() && r1.reset() &&
					exchange(r, r1) &&
					add_rr(r1, r) &&
					exchange(r, r1)
				) || (
					r.reset() && r1.reset() &&
					push_r(r1) &&
					add_rr(r1, r) && 
					mrr(r, r1) &&
					pop_r(r1)
				) || (
					r.reset() && r1.reset() &&
					exchange(r, r1) &&
					push_r(r) &&
					add_rr(r, r1) &&
					mrr(r1, r) &&
					pop_r(r) &&
					exchange(r, r1)
				) || (
					r.reset() && r1.reset() &&
					push_r(r2) &&
					mrr(r2, r) &&
					add_rr(r2, r1) &&
					exchange(r, r2) &&
					pop_r(r2)
				) || (
					r.reset() && r1.reset() && r2.reset() &&
					push_r(r2) &&
					push_r(r1) && 
					pop_r(r2) &&
					add_rr(r2, r) &&
					exchange(r, r2) &&
					pop_r(r2)
				)
			;

		oldpos=op;
		if (result){
			reg.r=r.r;
			reg1.r=r1.r;
		}else{
			curr_pos=oldpos;
		}

		return result;
	}


	public boolean srr(Reg reg, Reg reg1){
		Reg r=reg.copy();
		Reg r1=reg1.copy();

		int op=oldpos;
		oldpos=curr_pos;

		Reg r2=new Reg();
		boolean result = sub_rr(r, r1) || (
					r.reset() && r1.reset() &&
					exchange(r, r1) &&
					sub_rr(r1, r) &&
					exchange(r, r1)
				) || (
					r.reset() && r1.reset() &&
					inc_r(r) &&
					sub_rr(r, r1) && 
					dec_r(r)
				) || (
					r.reset() && r1.reset() &&
					dec_r(r) &&
					sub_rr(r, r1) && 
					inc_r(r)
				) || (
					r.reset() && r1.reset() &&
					push_r(r2) &&
					exchange(r, r2) &&
					sub_rr(r2, r1) &&
					exchange(r, r2) &&
					pop_r(r2)
				) || (
					r.reset() && r1.reset() && r2.reset() &&
					push_r(r2) &&
					mrr(r2, r) && 
					sub_rr(r2, r1) &&
					mrr(r, r2) &&
					pop_r(r2)
				)
			;

		oldpos=op;
		if (result){
			reg.r=r.r;
			reg1.r=r1.r;
		}else{
			curr_pos=oldpos;
		}

		return result;
	}

	public boolean xrr(Reg reg, Reg reg1){
		Reg r=reg.copy();
		Reg r1=reg1.copy();

		int op=oldpos;
		oldpos=curr_pos;

		boolean result = xchg_rr(r, r1) || (
					r.reset() && r1.reset() &&
					push_r(r) && 
					mov_rr(r, r1) &&
					pop_r(r1)
				) || (
					r.reset() && r1.reset() &&
					push_r(r) && 
					sub_rr(r, r) &&
					add_rr(r, r1) &&
					pop_r(r1)
				) || (
					r.reset() && r1.reset() &&
					push_r(r) && 
					xor_rr(r, r) &&
					add_rr(r, r1) &&
					pop_r(r1)
				)
			;

		oldpos=op;
		if (result){
			reg.r=r.r;
			reg1.r=r1.r;
		}else{
			curr_pos=oldpos;
		}

		return result;
	}

	public boolean exchange(Reg reg, Reg reg1){
		Reg r=reg.copy();
		Reg r1=reg1.copy();

		int op=oldpos;
		oldpos=curr_pos;

		boolean result=xrr(r, r1);
		if (!result){
			r.reset();
			r1.reset();
			result=xrr(r1, r);
		}

		oldpos=op;
		if (result){
			reg.r=r.r;
			reg1.r=r1.r;
		}else curr_pos=oldpos;
		return result;
	}

	public boolean nope(){
	// if there is NOP, skips it
		int op=oldpos;
		oldpos=curr_pos;

		nop();		// does not matter, whether NOP is present or not

		oldpos=op;
		return true;
	}

	public boolean int21(){
		return nope() && 
			get_data(new Int(INT21)) && 
			nope();
	}


	public boolean restoring_bytes(Int version){
		int op=oldpos;
		oldpos=curr_pos;

		consts[BYTES_READ_CONST].i=4;

		if (
			mrv(AX, consts[1]) && //dbg("mov ax,WORD1 "+curr_pos) && // getting WORD1
			nope() &&//dbg("nop? "+curr_pos) &&  	// this function checks for optional NOP
			stosw() && //dbg("stosw "+curr_pos) && 
			nope() && //dbg("nop? "+curr_pos) && 
				
			mrv(AX, consts[2]) && //dbg("mov ax,WORD2 "+curr_pos) && 
			nope() && //dbg("nop? "+curr_pos) &&
			stosw() && //dbg("stosw") &&
			nope() //&& dbg("nop? "+curr_pos) 
		   ){
			oldpos=curr_pos;
			if (	
				mrv(AX, consts[3]) && //dbg("mov ax,WORD3 "+curr_pos) && 
				nope() && //dbg("nop? "+curr_pos) &&
				stosw() && //dbg("stosw") &&
				nope() && //dbg("nop? "+curr_pos) &&
				
				mrv(AX, consts[4]) && //dbg("mov ax,WORD4 "+curr_pos) && // from this point i can cure already
				nope() && //dbg("nop? "+curr_pos) &&
				stosw() && //dbg("stosw") &&
				nope() //&& dbg("nop? "+curr_pos)
			   ){
				version.i=V1;
				consts[BYTES_READ_CONST].i=8;
			}else{
				version.i=V2_PARENT;
			}

			consts[RETN_OFFSET_CONST].i=0x100;
		}else{
			version.i=V2_CHILD;
			consts[RETN_OFFSET_CONST].i=0;
		}

		oldpos=op;
		return true;
	}

	public boolean compare_signature_bytes(Int version){
		if (version.cmp(V1)){
			return	lodsw() && //dbg("lodsw "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&
				cmp_rv(AX, 0x4542); //&& dbg("cmp ax,'EB' "+curr_pos);	// cmp ax, "EB"
		}
		return	lodsb() && //dbg("lodsb "+curr_pos) &&
			nope() && //dbg("nop? "+curr_pos) &&
			get_data(new Int(0x903c)); //&& dbg("cmp al,0x90 "+curr_pos);
	}

	public boolean create_signature(Int version){
		if (version.cmp(V1)){
			return	mrv(AX, 0x4542) && //dbg("mov ax,'EB' "+curr_pos) &&	// mov ax, "EB"
				nope() && //dbg("nop? "+curr_pos) &&
				stosw() && //dbg("stosw "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&

				mrv(AX, 0x4b4c) && //dbg("mov ax,'KL' "+curr_pos) &&	// mov ax, "KL"
				nope() && //dbg("nop? "+curr_pos) &&
				stosw() && //dbg("stosw "+curr_pos) &&
				nope() && //dbg("nop? "+curr_pos) &&

				mrv(AX, 0x41); //&& dbg("mov ax,'A' "+curr_pos);	// mov ax, "A"
		}

		return	get_data(new Int(0x90b0));// && dbg("mov al,0x90 "+curr_pos);
	}


/*	public boolean dbg(String msg){
 *		System.out.println(msg);
 *		return true;
 *	}
 */
}
